\documentclass{beamer}

\usepackage{amsmath}
\usepackage{graphicx}
\usepackage{siunitx}

\usepackage{caption}
\usepackage{subcaption}

% Set Frame Titles
\setbeamercolor{frametitle}{fg=black}
\setbeamerfont{frametitle}{size=\Huge}

% Set Main Titles
\setbeamercolor{title}{fg=black}
\setbeamerfont{title}{size=\Huge}

% Remove Footer Symbols
\setbeamertemplate{navigation symbols}{}

% Add line number and author name to footer
\setbeamertemplate{footline}{
    \usebeamerfont{footline}%
    \usebeamercolor[fg]{footline}%
    \hspace*{\fill}%
    \insertshortauthor[width={3cm}, center]%
    \hspace*{\fill}%
    \insertframenumber/\inserttotalframenumber%
    \hspace{1em}%
    \vspace{1em}%	
}

% Itemize should use black circles
\setbeamertemplate{itemize items}[circle]
\setbeamercolor{itemize item}{fg=black}

\usepackage{physics}

% coloured text
\definecolor{cgreen}{RGB}{112, 173, 71}
\definecolor{cred}{rgb}{0.8, 0.0, 0.0}
\definecolor{cblue}{RGB}{91, 155, 213}
\definecolor{bananayellow}{rgb}{1.0, 0.88, 0.21}

\setbeamercolor{alerted text}{fg=yellow}
\newcommand{\red}[1]{\textcolor{cred}{#1}}
\newcommand{\blue}[1]{\textcolor{cblue}{#1}}
\newcommand{\green}[1]{\textcolor{cgreen}{#1}}

\usetheme{default}
\usefonttheme{serif}

\title{Python GUI's with PyQt}
\author{David Posthuma de Boer}
\begin{document}
\maketitle
   
\section{Introduction}
    \begin{frame}
    \frametitle{Introduction}
    %\framesubtitle{subtitle}
    \begin{enumerate}
        \item How to get the tools
        \item Use QtDesigner to make a user interface
        \item Convert that to native python code
        \item Use that code to open a GUI
        \item Modify that code to add custom elements or add events etc        
    \end{enumerate}
    \end{frame}
   
   
\section{Tools}
\begin{frame}
\centering
\huge{Getting the Tools}
\end{frame}
%   \begin{frame}
%   \frametitle{Qt Tools}
%   \begin{itemize}[<+->]
%       \item \blue{QtDesigner} is a GUI tool for making QT GUI's
%       \item \green{QtCreator} is the official IDE produced by QT
%       \item \green{QtCreator} includes \blue{QtDesigner} but is much larger\\ 
%       \tiny{(3Gb compared to 30Mb)}
%   \end{itemize}
%    \begin{center}
%    \includegraphics[width=0.7\textwidth]{images/qt_designer.png}
%    \end{center}
%    \end{frame}

   \begin{frame}
   \frametitle{Getting the Tools on Windows}
   To make Qt GUi's with python you will need:
    \begin{itemize}[<+->]
        \item \textbf{Python}\\For Windows use Anaconda: 
        \url{anaconda.com}
        \item \textbf{PyQt5}\\Comes with Anaconda, otherwise use pip
        \item \textbf{QtDesigner}\\Comes with Anaconda, run ``designer'' from 
        terminal
    \end{itemize}
    \end{frame}



\section{Using the Tools}
\begin{frame}
\centering
\huge{Using the Tools}
\end{frame}

\begin{frame}
\frametitle{Overview}
%\framesubtitle{subtitle}
Steps for making a GUI with PyQT:\\
\begin{enumerate}
    \item Use QtDesigner to make a user interface
    \item Convert that to native python code
    \item Make a python file which imports that UI
    \item Add code for any additional UI elements or buttons etc
\end{enumerate}
\end{frame}
   
   
\subsection{QtDesigner}
    \begin{frame}
    \centering
    \huge{User Interface with QtDesigner}
    \end{frame}
    \begin{frame}
    \frametitle{New Main Window UI}
    \begin{center}
    \includegraphics[width=1.0\textwidth]{images/new_main_window.png}
    \end{center}
    \end{frame}
    
    \begin{frame}
    \frametitle{Add Layout}
    Add a Grid Layout to the window
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/add_layout.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Set UI Layout}
    Select the window and click ``Lay Out Horizontally''
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/set_layout.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Add Button Layout}
    Add a Vertical Layout to the Horizontal Layout
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/button_layout.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Add Buttons}
    Drag buttons into vertical layout, blue line indicates position
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/add_buttons.png}
    \end{center}
    \end{frame}
    
    \begin{frame}
    \frametitle{Add Spacer}
    Drag a Horizontal Spacer to left of buttons (note the blue line!)
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/add_spacer.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Other Objects}
    Added Line Edits and vertical spacer
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/window_complete.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Set Names and Text}
    In property editor set \texttt{objectName}, \texttt{Text} and for
    Line Edits \texttt{placeholderText}.
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/set_names.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Save UI}
    Click File $\rightarrow$ Save, and save a .ui file
    \end{frame}

\subsection{Converting UI to Python}
    \begin{frame}
    \centering
    \huge{Converting User Interface to Python}
    \end{frame}
    \begin{frame}
    \frametitle{Native Python Code}
    \begin{itemize}[<-+>]
        \item In Anaconda Prompt \texttt{cd} to the directory with the ui file 
        and 
        run\\ \texttt{pyui5 main\_window.ui -o main\_window.py}
        \begin{center}
        \includegraphics[width=1.0\textwidth]{images/pyuic5.png}
        \end{center}
    \end{itemize}
    \end{frame}

\subsection{Running GUI}
    \begin{frame}
    \centering
    \huge{Running GUI}
    \end{frame}

    \begin{frame}
    \frametitle{Testing}
    We need another python file which will call the python file we just made.
    The code in this file is quite short, and will always be basically the same.
    \begin{center}
        \includegraphics[width=1.0\textwidth]{images/template_qt.png}
    \end{center}
    \end{frame}

    \begin{frame}
    \frametitle{Testing}
    Run this python file
    \begin{center}
        \includegraphics[width=0.8\textwidth]{images/run_gui.png}
    \end{center}
    \end{frame}



\subsection{Adding Custom Elements and Events}
    \begin{frame}
    \centering
    \huge{Custom Elements and Events}
    \end{frame}

    \begin{frame}
    \frametitle{Adding Matplotlib Graph}
    Matplotlib have a Qt widget which we can add. We make a canvas, a figure 
    and a set of axes then add them to the ui \footnote{\tiny{Official 
    matplotlib 
    example 
    \url{https://matplotlib.org/gallery/user_interfaces/embedding_in_qt_sgskip.html}}}.
    \begin{center}
    \only<1>{
    \includegraphics[width=0.8\textwidth]{images/add_matplotlib.png}    
    }
    \only<2>{
    \includegraphics[width=0.7\textwidth]{images/added_matplotlib.png}    
    }
    \end{center}
    \end{frame}


    \begin{frame}
    \frametitle{Making Buttons Work}
    To make the buttons work we add a click event signal and a function to
    run. Names are as specified in QtDesigner.
    \begin{center}
        \only<1>{
        \includegraphics[width=0.8\textwidth]{images/buttons_work.png}    
        }
        \only<2>{
        \includegraphics[width=0.7\textwidth]{images/added_matplotlib.png}   
        }
        \only<3>{
        \includegraphics[width=0.7\textwidth]{images/button_clicked.png}  
        }
    \end{center}
    \end{frame}

\section{Conclusion}
\begin{frame}
\centering
\huge{Conclusion}
\end{frame}

\begin{frame}
\frametitle{Conclusion}
In summary we have
\begin{itemize}[<+->]
    \item Made a UI with QtDesigner
    \item Converted that to native python code
    \item Made another file and imported that UI
    \item Added a Matplotlib graph \\ \tiny{Quite a lot of code, but it's 
    always the same}
    \item Made a button work
\end{itemize}
\end{frame}

\begin{frame}
\frametitle{Final Code}
%\framesubtitle{subtitle}
\centering
\includegraphics[width=0.9\linewidth]{images/total_code.png}
\end{frame}

\end{document}
